# Copyright (c) 2000-2010, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%bcond_without maven

%define section free

%global bname archetype
%global oname maven-archetype
%global namedversion 2.0-alpha-5

Name:           maven-archetype2
Version:        2.0
Release:        0.a5.1%{?dist}
Epoch:          0
Summary:        Maven Archetype 2
License:        ASL 2.0
Group:          Development/Java
URL:            http://maven.apache.org/
# svn -r 1041154 export http://svn.apache.org/repos/asf/maven/archetype/tags/maven-archetype-2.0-alpha-5/ && tar cjf maven-archetype-2.0-alpha-5.tar.bz2 maven-archetype-2.0-alpha-5
Source0:        %{oname}-%{namedversion}.tar.bz2
Source1:        %{name}-build.xml
Source2:        %{name}-jpp-depmap.xml
Source4:        %{name}-parent-2.pom
Source5:        %{name}-autogenerated-files.tar.gz
Patch0:         maven-archetype-plugin-pom.patch
Patch1:         maven-archetype-compile.patch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires:       java >= 0:1.5.0
Requires:       jpackage-utils
Requires:       geronimo-jta-1.0.1B-api
Requires:       jakarta-commons-io
Requires:       jchardet
Requires:       maven-shared-invoker
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  ant-antlr
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  junit
%if %with maven
BuildRequires:  maven2-common-poms
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-ant
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-war
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-shared-invoker
BuildRequires:  maven-shared-plugin-testing-harness
BuildRequires:  maven-wagon
BuildRequires:  modello-maven-plugin >= 0:1.0-0.a17
# FIXME: (dwalluck): This has the maven fragment for jetty6-maven2-plugins
BuildRequires:  jetty6
BuildRequires:  jetty6-core
BuildRequires:  jetty6-maven2-plugins
BuildRequires:  plexus-maven-plugin >= 0:1.3.5
BuildRequires:  xpp3-minimal
%endif
BuildRequires:  cargo
BuildRequires:  easymock-java5
BuildRequires:  modello >= 0:1.0-0.a17
BuildRequires:  jakarta-commons-io
BuildRequires:  jchardet
BuildRequires:  geronimo-genesis
BuildRequires:  geronimo-jta-1.0.1B-api
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Maven Archetypes.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%prep
%setup -q -n %{oname}-%{namedversion}
cp -p %{SOURCE1} build.xml
#gzip -dc %{SOURCE4} | tar xf -
%if %without maven
gzip -dc %{SOURCE5} | tar xf -
%endif
#%%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL
mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/
cp -p %{SOURCE4} $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/org.apache.maven.archetype-maven-archetype-parent.pom

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2_SETTINGS=$(pwd)/settings.xml
%if %with maven
    %{_bindir}/mvn-jpp \
        -e \
        -Dmaven.test.skip=true \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        install javadoc:aggregate
%else
export CLASSPATH=$(build-classpath \
classworlds \
modello/core \
modello/plugin-xml \
modello/plugin-xpp3 \
modello/plugin-xsd \
plexus/classworlds \
plexus/containers-component-api \
plexus/containers-container-default \
plexus/utils \
)

pushd archetype-common
java org.codehaus.modello.ModelloCli src/main/mdo/archetype.mdo xpp3-reader src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/archetype.mdo java src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/archetype.mdo xpp3-writer src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/archetype.mdo xsd src/main/java 1.0.0 false

java org.codehaus.modello.ModelloCli src/main/mdo/archetype-common.mdo xpp3-reader src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/archetype-common.mdo java src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/archetype-common.mdo xpp3-writer src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/archetype-common.mdo xsd src/main/java 1.0.0 false

java org.codehaus.modello.ModelloCli src/main/mdo/archetype-registry.mdo xpp3-reader src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/archetype-registry.mdo java src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/archetype-registry.mdo xpp3-writer src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/archetype-registry.mdo xsd src/main/java 1.0.0 false

java org.codehaus.modello.ModelloCli src/main/mdo/archetype-descriptor.mdo xpp3-reader src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/archetype-descriptor.mdo java src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/archetype-descriptor.mdo xpp3-writer src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/archetype-descriptor.mdo xsd src/main/java 1.0.0 false

java org.codehaus.modello.ModelloCli src/main/mdo/archetype-catalog.mdo xpp3-reader src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/archetype-catalog.mdo java src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/archetype-catalog.mdo xpp3-writer src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/archetype-catalog.mdo xsd src/main/java 1.0.0 false
popd


mkdir -p .m2/repository/org/mortbay/jetty/jetty-util/6.1.7/
ln -sf $(build-classpath jetty6/jetty6-util) .m2/repository/org/mortbay/jetty/jetty-util/6.1.7/jetty-util-6.1.7.jar

export CLASSPATH=$(build-classpath \
cargo/cargo-core-api-container \
cargo/cargo-core-api-generic \
cargo/cargo-core-api-module \
cargo/cargo-core-api-util \
cargo/cargo-core-container-jetty \
classworlds \
commons-codec \
commons-httpclient \
commons-io \
commons-lang \
easymock-java5 \
jchardet \
jdom \
jetty6/jetty6 \
jetty6/jetty6-util \
jetty6/jsp-2.0/jasper5-compiler \
jetty6/jsp-2.0/jasper5-runtime \
jsp_2_0_api \
junit \
maven2/artifact \
maven2/artifact-manager \
maven2/core \
maven2/model \
maven2/plugin-api \
maven2/plugin-descriptor \
maven2/profile \
maven2/project \
maven2/repository-metadata \
maven2/settings \
maven-shared/invoker \
maven-shared/plugin-testing-harness \
maven-wagon/file \
maven-wagon/http \
maven-wagon/provider-api \
plexus/container-default \
plexus/interactivity-api \
plexus/utils \
plexus/velocity \
servlet_2_4_api \
velocity \
)

CLASSPATH=$CLASSPATH:target/classes:target/test-classes
CLASSPATH=$CLASSPATH:src/test/resources
pushd archetype-testing
pushd archetype-proxy
   ant -Dmaven.settings.offline=true -Dbuild.sysclasspath=only package javadoc
#   CLASSPATH=$CLASSPATH:$(pwd)/target/archetype-proxy-%{namedversion}.jar
popd
pushd archetype-repository
   ant -Dmaven.settings.offline=true -Dbuild.sysclasspath=only package javadoc
#   CLASSPATH=$CLASSPATH:$(pwd)/target/archetype-repository-%{namedversion}.jar
popd
popd
pushd archetype-common
   rm src/test/java/org/apache/maven/archetype/repositorycrawler/DefaultRepositoryCrawlerTest.java
   rm src/test/java/org/apache/maven/archetype/test/ArchetyperRoundtripTest.java
   rm src/test/java/org/apache/maven/archetype/test/ArchetyperRoundtripWithProxyTest.java
   mkdir -p target/wars/
   cp ../archetype-testing/archetype-repository/target/archetype-repository-%{namedversion}.war \
       target/wars/archetype-repository.war
   ant -Dmaven.settings.offline=true -Dbuild.sysclasspath=only package javadoc
   CLASSPATH=$CLASSPATH:$(pwd)/target/archetype-common-%{namedversion}.jar
popd
pushd archetype-packaging
   ant -Dmaven.settings.offline=true -Dbuild.sysclasspath=only jar javadoc
   CLASSPATH=$CLASSPATH:$(pwd)/target/archetype-packaging-%{namedversion}.jar
popd
pushd archetype-plugin
   ant -Dmaven.settings.offline=true -Dbuild.sysclasspath=only jar javadoc
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT
# jars/poms
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.apache.maven.archetype maven-archetype %{namedversion} JPP/%{name} archetype
install -p -m 644 pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.%{name}-archetype.pom

install -p -m 644 archetype-common/target/archetype-common-%{namedversion}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/common-%{version}.jar
%add_to_maven_depmap org.apache.maven.archetype archetype-common %{namedversion} JPP/%{name} common
install -p -m 644 archetype-common/pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.%{name}-common.pom

install -p -m 644 archetype-packaging/target/archetype-packaging-%{namedversion}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/packaging-%{version}.jar
%add_to_maven_depmap org.apache.maven.archetype archetype-packaging %{namedversion} JPP/%{name} packaging
install -p -m 644 archetype-packaging/pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.%{name}-packaging.pom

%add_to_maven_depmap org.apache.maven.archetype archetype-testing %{namedversion} JPP/%{name} testing
install -p -m 644 archetype-testing/pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.%{name}-testing.pom

install -p -m 644 archetype-testing/archetype-proxy/target/archetype-proxy-%{namedversion}.war \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/proxy-%{version}.war
%add_to_maven_depmap org.apache.maven.archetype archetype-proxy %{namedversion} JPP/%{name} proxy
install -p -m 644 archetype-testing/archetype-proxy/pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.%{name}-proxy.pom

install -p -m 644 archetype-testing/archetype-repository/target/archetype-repository-%{namedversion}.war \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/repository-%{version}.war
%add_to_maven_depmap org.apache.maven.archetype archetype-repository %{namedversion} JPP/%{name} repository
install -p -m 644 archetype-testing/archetype-repository/pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.%{name}-repository.pom

install -p -m 644 archetype-plugin/target/%{oname}-plugin-%{namedversion}.jar \
    $RPM_BUILD_ROOT%{_javadir}/%{name}/archetype2-plugin-%{version}.jar
%add_to_maven_depmap org.apache.maven.plugins %{oname}-plugin %{namedversion} JPP/%{name} archetype2-plugin
install -p -m 644 archetype-plugin/pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-archetype2-plugin.pom

#(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for war in *-%{version}*.war; do ln -s ${war} $(echo $war | sed -e 's/-%{version}//' -e 's/\.war/.jar/'); done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -s ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%if %with maven
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
%else
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/proxy
cp -pr archetype-testing/archetype-proxy/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/proxy
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/repository
cp -pr archetype-testing/archetype-repository/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/repository
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/common
cp -pr archetype-common/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/common
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/plugin
cp -pr archetype-plugin/target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/plugin
%endif
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}*/%{name}
%{_javadir}*/%{name}/archetype2-plugin-%{version}.jar
%{_javadir}*/%{name}/archetype2-plugin.jar
%{_javadir}*/%{name}/common-%{version}.jar
%{_javadir}*/%{name}/common.jar
%{_javadir}*/%{name}/packaging-%{version}.jar
%{_javadir}*/%{name}/packaging.jar
%{_javadir}*/%{name}/proxy-%{version}.war
%{_javadir}*/%{name}/proxy.war
%{_javadir}*/%{name}/repository-%{version}.war
%{_javadir}*/%{name}/repository.war
%{_datadir}/maven2/poms/JPP.%{name}-archetype.pom
%{_datadir}/maven2/poms/JPP.%{name}-archetype2-plugin.pom
%{_datadir}/maven2/poms/JPP.%{name}-common.pom
%{_datadir}/maven2/poms/JPP.%{name}-packaging.pom
%{_datadir}/maven2/poms/JPP.%{name}-proxy.pom
%{_datadir}/maven2/poms/JPP.%{name}-repository.pom
%{_datadir}/maven2/poms/JPP.%{name}-testing.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Fri Sep 16 2011 David Walluck <dwalluck@redhat.com> 0:2.0-0.a5.1
- fixes for JPP-6

* Wed Dec 01 2010 David Walluck <dwalluck@redhat.com> 0:2.0-0.a5.0.1
- 2.0-alpha-5
- put plugin into %%_javadir
- fix pom name
- use explicit file list
- skip tests as they require network
- update BuildRequires for brew
- fix Release

* Sun Nov 28 2010 Ralph Apel <r.apel at r-apel.de> 0:2.0-0.a3.2
- Adapt to JPP6

* Sat Sep 27 2008 Ralph Apel <r.apel at r-apel.de> 0:2.0-0.a3.1.jpp5
- First release
